package com.alibaba.tae.demo.rpc;

import com.alibaba.tae.demo.rpc.DemoObject;
import com.alibaba.appengine.api.rpc.ReferenceConfig;
import com.alibaba.appengine.api.rpc.RpcFactory;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * @author ding.lid
 */
public class RpcConsumer extends HttpServlet {
    private static final long serialVersionUID = -2359366324351384788L;

    HelloService reference;

    @Override
    public void init() throws ServletException {
        super.init();

        ReferenceConfig<HelloService> referenceConfig = new ReferenceConfig<HelloService>();
        referenceConfig.setInterfaceClass(HelloService.class);
        reference = RpcFactory.getReference(referenceConfig);
    }

    @Override
    public void destroy() {
        super.destroy();
    }

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        resp.getWriter().println("RPC Invocation Result:");
        resp.getWriter().println(reference.hello());
        resp.getWriter().println("======================");

        DemoObject demoObject = new DemoObject("default", 0);
        if (null != req.getParameter("a")) {
           demoObject.setA(req.getParameter("a")); 
        }
        if (null != req.getParameter("b")) {
            demoObject.setB(Integer.parseInt(req.getParameter("b")));
        }
        resp.getWriter().println("Input: " + demoObject +  ", output: " + reference.echo(demoObject));
 //       resp.getWriter().println("Input: " + demoObject);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doGet(req, resp);
    }
}
